@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

############################################
#                                          #
#  The script "mkstubs.bat" is             #
#                                          #
#  Copyright (C) 2005 by Steffen Beyer.    #
#  All rights reserved.                    #
#                                          #
#                                          #
#  The script "mkstubs.bat" is             #
#                                          #
#  free software; you can redistribute it  #
#  and/or modify it under the same terms   #
#  as Perl itself.                         #
#                                          #
############################################

use strict;

my($Self,$Top,@Task,$Item);

$Self = $0; $Self =~ s!^.*[\/\\]!!; $Self =~ s!\.[^\.\/\\]*$!!;

unless (@ARGV)
{
    die "Usage: $Self <Directory>\n";
}

while (@ARGV)
{
    $Top = shift;
    unless (opendir(TOP, $Top))
    {
        warn "$Self: can't open directory <$Top>: $!\n";
        next;
    }
    @Task = sort
            grep { !/^\.\.?$/ and (-d "$Top/$_") }
            readdir(TOP);
    unless (closedir(TOP))
    {
        warn "$Self: can't close directory <$Top>: $!\n";
    }
    foreach $Item (@Task) { Process($Top,$Item); }
}

sub Process
{
    my($Base,$Name) = @_;
    my(@List,@Meta,$Dir,$File,$Count,$Track,$Title);

    $Dir = "$Base/$Name";
    unless (opendir(DIR, $Dir))
    {
        warn "$Self: can't open directory <$Dir>: $!\n";
        return;
    }
    @List = grep { !/^\.\.?$/ }
            readdir(DIR);
    unless (closedir(DIR))
    {
        warn "$Self: can't close directory <$Dir>: $!\n";
    }
    @Meta = grep { /\.txt$/i }
            @List;
    @List = map  { $_->[0] }
            sort { $a->[1] <=> $b->[1] || lc($a->[0]) cmp lc($b->[0]) || $a->[0] cmp $b->[0] }
            map  { if (/^(\d+)/) { [$_,$1] } elsif (/^.*?\D(\d+)\.wav$/i) { [$_,$1] } else { [$_,0] } }
            grep { (-f "$Dir/$_") and /^(?:\d+.*|.*?\D\d+)\.wav$/i }
            @List;
    if (@Meta > 0)
    {
        warn "$Self: already one possible metafile found in directory <$Dir>!\n";
        return;
    }
    $File = $Dir . '/' . $Name . '.txt';
    unless (open(FILE, ">$File"))
    {
        warn "$Self: can't open metafile <$File>: $!\n";
        return;
    }
    unless (print(FILE "\n\n\n\n"))
    {
        warn "$Self: can't print metafile <$File>: $!\n";
        close(FILE);
        return;
    }
    $Count = 0;
    while (@List)
    {
        $Track = sprintf("%02d", ++$Count);
        $Title = shift(@List);
        $Title =~ s!_+! !g;
        $Title =~ s!^\s+!!;
        $Title =~ s!^\d+[\:\.\s-]*!!;
        $Title =~ s!\s+$!!;
        $Title =~ s!\s*\[[^\[\]]*\]$!!;
        $Title =~ s!\s*\.+[^\.\s\/\\]*$!!;
        $Title =~ s!\s+! !g;
        unless (print(FILE "${Track}: ${Title}\n"))
        {
            warn "$Self: can't print metafile <$File>: $!\n";
            close(FILE);
            return;
        }
    }
    unless (close(FILE))
    {
        warn "$Self: can't close metafile <$File>: $!\n";
    }
    print "Wrote metafile <${Name}.txt>\n";
}

__END__
:endofperl
